<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   close="titlewindowCloseHandler(event)" 
			   creationComplete="creationCompleteHandler(event)" 
			   title="Pesquisa de Situação Nota Fiscal" 
			   xmlns:visual="br.com.desenv.framework.component.visual.*"
			   maxWidth="1200" maxHeight="700" 
			    xmlns:autoComplete="br.com.desenv.framework.component.visual.autoComplete.*">
	
	<fx:Style source="../../../framework/util/estilo.css"/>
	
	
	<fx:Metadata>
		[Event(name="SituacaoNotaFiscalSelecionadoEvent")]
	</fx:Metadata>
	
	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.controls.DateField;
			import mx.validators.Validator;
			import spark.events.TitleWindowBoundsEvent;
			
			
			import br.com.desenv.nepalign.vo.Page;
			import br.com.desenv.nepalign.vo.SituacaoNotaFiscal;

			
			[Bindable]
			public var listaSituacaoNotaFiscal: ArrayCollection = new ArrayCollection();
			private var pageNumber: int = 1;
			private var totalRecords: int;
			private var pageSize: int = 15;
			private var lastPage: int = 1;
			

			
			private var situacaoNotaFiscalComponenteDetalhe: SituacaoNotaFiscalComponenteDetalhe;

			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			
			
			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}

			private function montarObjetoFiltro(): SituacaoNotaFiscal
			{
				var situacaoNotaFiscalFiltro: SituacaoNotaFiscal = new SituacaoNotaFiscal();
				
				situacaoNotaFiscalFiltro.descricao = ignTextInputDescricaoPesquisa.text == ""?null:"%"+ignTextInputDescricaoPesquisa.text+"%";
				return situacaoNotaFiscalFiltro;
			}
			
			private function creationCompleteHandler( event: FlexEvent ): void {
				carregarListaValidacao();
				
				var remoteObjectSituacaoNotaFiscal: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("situacaoNotaFiscalService", listarResultHandler);	
				
				
				var situacaoNotaFiscalFiltro: SituacaoNotaFiscal = new SituacaoNotaFiscal();
				remoteObjectSituacaoNotaFiscal.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, situacaoNotaFiscalFiltro); 
			}
			
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- RETORNO DA FUNCAO LISTAR  --------------------------------	
			
			private function listarResultHandler( event: ResultEvent ): void {
				var paginaSituacaoNotaFiscal: Page = event.result as Page;
				pageNumber = paginaSituacaoNotaFiscal.pageNumber;
				totalRecords = paginaSituacaoNotaFiscal.totalRecords;
				lastPage = paginaSituacaoNotaFiscal.lastPage();
				listaSituacaoNotaFiscal = paginaSituacaoNotaFiscal.recordList;
				labelPaginaAtual.text = "" + paginaSituacaoNotaFiscal.pageNumber;
				labelTotalRegistro.text = "Total de Registros " + paginaSituacaoNotaFiscal.totalRecords;
			}

// CARREGANDO COMBOS			

// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				
	
			
			
// -------------FUNCAO DE FILTRAR  -------------------------------------------------------			

			private function buttonFiltrarClickHandler( event: MouseEvent ): void {
				if (validar(event))
				{
					var remoteObjectSituacaoNotaFiscal: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("situacaoNotaFiscalService", listarResultHandler);	
					remoteObjectSituacaoNotaFiscal.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, montarObjetoFiltro());
				}	 
			}
			
// -------------FUNCOES DE INSERIR E ATUALIZAR  -------------------------------------------------------			

			private function buttonInserir_clickHandler( event: MouseEvent): void 
			{
				var situacaoNotaFiscalComponenteCadastro: SituacaoNotaFiscalComponenteCadastro = new SituacaoNotaFiscalComponenteCadastro();
				situacaoNotaFiscalComponenteCadastro.situacaoNotaFiscal = new SituacaoNotaFiscal(); 
				situacaoNotaFiscalComponenteCadastro.addEventListener("SituacaoNotaFiscalIncluidoEvent", atualizarListaSituacaoNotaFiscalPorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(situacaoNotaFiscalComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(situacaoNotaFiscalComponenteCadastro);
			}
			
			protected function buttonFechar_clickHandler(event:MouseEvent):void
			{
				var situacaoNotaFiscalSelecionado: SituacaoNotaFiscal = datagridListaSituacaoNotaFiscal.selectedItem as SituacaoNotaFiscal;
				this.dispatchEvent(new ResultEvent("SituacaoNotaFiscalSelecionadoEvent",false, true, situacaoNotaFiscalSelecionado, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			protected function datagridListaSituacaoNotaFiscal_doubleClickHandler(event:MouseEvent):void
			{
				situacaoNotaFiscalComponenteDetalhe = new SituacaoNotaFiscalComponenteDetalhe();
				situacaoNotaFiscalComponenteDetalhe.situacaoNotaFiscal = datagridListaSituacaoNotaFiscal.selectedItem as SituacaoNotaFiscal;
				situacaoNotaFiscalComponenteDetalhe.addEventListener("SituacaoNotaFiscalExcluidoEvent", atualizarListaSituacaoNotaFiscalPorExclusaoResultHandler);
				situacaoNotaFiscalComponenteDetalhe.addEventListener("SituacaoNotaFiscalAtualizadoEvent", atualizarListaSituacaoNotaFiscalPorAtualizacaoResultHandler);
				UPCPopUpManager.instance.addPopUp(situacaoNotaFiscalComponenteDetalhe, this, true);
				UPCPopUpManager.instance.centerWindow(situacaoNotaFiscalComponenteDetalhe);
			}
			
			
			private function atualizarListaSituacaoNotaFiscalPorInclusaoResultHandler(e:Event):void
			{
				var remoteObjectSituacaoNotaFiscal: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("situacaoNotaFiscalService", listarResultHandler);	
				remoteObjectSituacaoNotaFiscal.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro()); 
			}
			
			private function atualizarListaSituacaoNotaFiscalPorAtualizacaoResultHandler(e:Event):void
			{
				var remoteObjectSituacaoNotaFiscal: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("situacaoNotaFiscalService", listarResultHandler);	
				remoteObjectSituacaoNotaFiscal.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
				
			}
			
			
			private function atualizarListaSituacaoNotaFiscalPorExclusaoResultHandler(e:Event):void
			{
				var remoteObjectSituacaoNotaFiscal: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("situacaoNotaFiscalService", listarResultHandler);	
				remoteObjectSituacaoNotaFiscal.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
			}
			
			
			
			
		
// -------------FUNCOES DE NAVEGACAO -------------------------------------------------------			
			protected function linkButtonProximaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectSituacaoNotaFiscal: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("situacaoNotaFiscalService", listarResultHandler);	

				if (pageNumber < lastPage)
				{
					remoteObjectSituacaoNotaFiscal.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber + 1), montarObjetoFiltro());
				}
				else
				{
					remoteObjectSituacaoNotaFiscal.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro());
				}				
			}
			
			protected function linkButtonAnteriorPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectSituacaoNotaFiscal: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("situacaoNotaFiscalService", listarResultHandler);	
				
				if (pageNumber > 1)
				{
					remoteObjectSituacaoNotaFiscal.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber - 1) , montarObjetoFiltro());
				}
				else
				{
					remoteObjectSituacaoNotaFiscal.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro());
				}
			}
			
			protected function linkButtonPrimeiraPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectSituacaoNotaFiscal: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("situacaoNotaFiscalService", listarResultHandler);	
				remoteObjectSituacaoNotaFiscal.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro()); 
			}
			
			protected function linkButtonUltimaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectSituacaoNotaFiscal: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("situacaoNotaFiscalService", listarResultHandler);	
				remoteObjectSituacaoNotaFiscal.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage , montarObjetoFiltro()); 
			}
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
		<s:ArrayCollection id="listaOpcaoSimNao">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="Sim"/>
			<fx:Object codigo="N" valor="Nao"/>
		</s:ArrayCollection>
			
	</fx:Declarations>
	
	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="600" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>


			<mx:GridItem styleName="gridLabel">
				<s:Label text="Descrição:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor" colSpan="3">
				<s:VGroup>
					<s:Label id="labelValidacaoDescricaoPesquisa" styleName="labelValidacao" text="{ignTextInputDescricaoPesquisa.errorString}"/>
					<visual:IgnTextInput id="ignTextInputDescricaoPesquisa" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}" width="300"/>
				</s:VGroup>
			</mx:GridItem>



 			<mx:GridItem colSpan="2">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="right">
				<mx:Button id="buttonFiltrar" label="Filtrar" click="buttonFiltrarClickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4">
				<s:Spacer/>	
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				
				
				<mx:LinkButton id="linkButtonPrimeiraPagina" label="&lt;&lt;" click="linkButtonPrimeiraPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonAnteriorPagina" label="&lt;" click="linkButtonAnteriorPagina_clickHandler(event)"/>
				<mx:Label id="labelPaginaAtual" text=""/>
				<mx:LinkButton id="linkButtonProximaPagina" label="&gt;" click="linkButtonProximaPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonUltimaPagina" label="&gt;&gt;" click="linkButtonUltimaPagina_clickHandler(event)"/>				
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<mx:DataGrid id="datagridListaSituacaoNotaFiscal"  width="100%" verticalScrollPolicy="on" horizontalScrollPolicy="on" dataProvider="{listaSituacaoNotaFiscal}" doubleClick="datagridListaSituacaoNotaFiscal_doubleClickHandler(event)" doubleClickEnabled="true">
					<mx:columns>
						<mx:DataGridColumn visible="false" dataField="id"/>
						<mx:DataGridColumn dataField="descricao" headerText="Descrição" resizable="true"/>
					</mx:columns>
				</mx:DataGrid>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			
			<mx:GridItem colSpan="2" horizontalAlign="left">
				<mx:Label id="labelTotalRegistro" text=""/>
			</mx:GridItem>
			<mx:GridItem colSpan="2" horizontalAlign="right">
				<mx:Button id="buttonInserir" label="Novo" click="buttonInserir_clickHandler(event)"/>
				<mx:Button id="buttonFechar" label="Fechar" click="buttonFechar_clickHandler(event)"/>
			</mx:GridItem>	
		</mx:GridRow>
				
	</mx:Grid>
</s:TitleWindow>
